#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>


/* Deklaracija asemblerske funkcije */
double variance(double * x, int n); 

/* Provera */
double c_variance(double * x, int n)
{
  double E = 0, D = 0;
  int i;
  
  for(i = 0; i < n; i++)
    E += exp(x[i]) / (x[i]*x[i]*x[i] + 1);

  E /= n;

  for(i = 0; i < n; i++)
    D += (exp(x[i]) / (x[i]*x[i]*x[i] + 1) - E) *
      (exp(x[i]) / (x[i]*x[i]*x[i] + 1) - E);

  D /= n;
  
  return D;
}


/* Test program */
int main()
{
  
  double * x;  /* Niz vrednosti slucajne velicine X */
  int n;  /* Broj vrednosti slucajne velicine X */
  int i; /* Brojac u petlji */
  
  /* Ucitavamo n */
  assert(scanf("%d", &n) == 1);
  assert(n > 0);

  /* Alociramo prostor za niz */
  assert((x = malloc(n * sizeof(double))) != NULL);
  
  /* Ucitavamo vrednosti */
  for(i = 0; i < n; i++)
    assert(scanf("%lf", &x[i]) == 1);
    
  
  /* Pozivamo asemblersku funkciju */
  printf("%f\n", variance(x, n));

  /* Provera */
  printf("%f\n", c_variance(x, n));

  /* Oslobadjamo prostor za niz */
  free(x);

  return EXIT_SUCCESS;
}
